diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.31/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.30.1/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,196 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015, NYU WIRELESS, Tandon School of Engineering,
+ * New York University
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
+#define THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
+
+#include "ns3/spectrum-propagation-loss-model.h"
+#include <complex.h>
+#include <map>
+#include <unordered_map>
+#include "ns3/matrix-based-channel-model.h"
+
+namespace ns3 {
+
+class NetDevice;
+class ChannelConditionModel;
+class ChannelCondition;
+
+/**
+ * \ingroup spectrum
+ * \brief 3GPP Spectrum Propagation Loss Model
+ *
+ * This class models the frequency dependent propagation phenomena in the way
+ * described by 3GPP TR 38.901 document. The main method is DoCalcRxPowerSpectralDensity,
+ * which takes as input the power spectral density (PSD) of the transmitted signal,
+ * the mobility models of the transmitting node and receiving node, and
+ * returns the PSD of the received signal.
+ *
+ * \see MatrixBasedChannelModel
+ * \see ThreeGppAntennaArrayModel
+ * \see ChannelCondition
+ */
+class ThreeGppSpectrumPropagationLossModel : public SpectrumPropagationLossModel
+{
+public:
+  /**
+   * Constructor
+   */
+  ThreeGppSpectrumPropagationLossModel ();
+
+  /**
+   * Destructor
+   */
+  ~ThreeGppSpectrumPropagationLossModel ();
+  
+  void DoDispose () override;
+
+  /**
+   * Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId ();
+
+  /**
+   * Set the channel model object
+   * \param channel a pointer to an object implementing the MatrixBasedChannelModel interface
+   */
+  void SetChannelModel (Ptr<MatrixBasedChannelModel> channel);
+
+  /**
+   * Get the channel model object
+   * \return a pointer to the object implementing the MatrixBasedChannelModel interface
+   */
+  Ptr<MatrixBasedChannelModel> GetChannelModel() const;
+
+  /**
+   * Add a device-antenna pair
+   * \param n a pointer to the NetDevice
+   * \param a a pointer to the associated ThreeGppAntennaArrayModel
+   */
+  void AddDevice (Ptr<NetDevice> n, Ptr<const ThreeGppAntennaArrayModel> a);
+
+
+  /**
+   * Sets the value of an attribute belonging to the associated
+   * MatrixBasedChannelModel instance
+   * \param name name of the attribute
+   * \param value the attribute value
+   */
+  void SetChannelModelAttribute (const std::string &name, const AttributeValue &value);
+
+  /**
+   * Returns the value of an attribute belonging to the associated
+   * MatrixBasedChannelModel instance
+   * \param name name of the attribute
+   * \param where the result should be stored
+   */
+  void GetChannelModelAttribute (const std::string &name, AttributeValue &value) const;
+
+  /**
+   * \brief Computes the received PSD.
+   *
+   * This function computes the received PSD by applying the 3GPP fast fading
+   * model and the beamforming gain.
+   * In particular, it retrieves the matrix representing the channel between
+   * node a and node b, computes the corresponding long term component, i.e.,
+   * the product between the cluster matrices and the TX and RX beamforming
+   * vectors (w_rx^T H^n_ab w_tx), and accounts for the Doppler component and
+   * the propagation delay.
+   * To reduce the computational load, the long term component associated with
+   * a certain channel is cached and recomputed only when the channel realization
+   * is updated, or when the beamforming vectors change.
+   *
+   * \param txPsd tx PSD
+   * \param a first node mobility model
+   * \param b second node mobility model
+   *
+   * \return the received PSD
+   */
+  Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
+                                                           Ptr<const MobilityModel> a,
+                                                           Ptr<const MobilityModel> b) const override;
+
+private:
+  /**
+   * Data structure that stores the long term component for a tx-rx pair
+   */
+  struct LongTerm : public SimpleRefCount<LongTerm>
+  {
+    ThreeGppAntennaArrayModel::ComplexVector m_longTerm; //!< vector containing the long term component for each cluster
+    Ptr<const MatrixBasedChannelModel::ChannelMatrix> m_channel; //!< pointer to the channel matrix used to compute the long term
+    ThreeGppAntennaArrayModel::ComplexVector m_sW; //!< the beamforming vector for the node s used to compute the long term
+    ThreeGppAntennaArrayModel::ComplexVector m_uW; //!< the beamforming vector for the node u used to compute the long term
+  };
+
+  /**
+   * Get the operating frequency
+   * \return the operating frequency in Hz
+  */
+  double GetFrequency () const;
+
+  /**
+   * Looks for the long term component in m_longTermMap. If found, checks
+   * whether it has to be updated. If not found or if it has to be updated,
+   * calls the method CalcLongTerm to compute it.
+   * \param aId id of the first node
+   * \param bId id of the second node
+   * \param channelMatrix the channel matrix
+   * \param aW the beamforming vector of the first device
+   * \param bW the beamforming vector of the second device
+   * \return vector containing the long term compoenent for each cluster
+   */
+  ThreeGppAntennaArrayModel::ComplexVector GetLongTerm (uint32_t aId, uint32_t bId,
+                                                        Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                                        const ThreeGppAntennaArrayModel::ComplexVector &aW,
+                                                        const ThreeGppAntennaArrayModel::ComplexVector &bW) const;
+  /**
+   * Computes the long term component
+   * \param channelMatrix the channel matrix H
+   * \param sW the beamforming vector of the s device
+   * \param uW the beamforming vector of the u device
+   * \return the long term component
+   */
+  ThreeGppAntennaArrayModel::ComplexVector CalcLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                                         const ThreeGppAntennaArrayModel::ComplexVector &sW,
+                                                         const ThreeGppAntennaArrayModel::ComplexVector &uW) const;
+
+  /**
+   * Computes the beamforming gain and applies it to the tx PSD
+   * \param txPsd the tx PSD
+   * \param longTerm the long term component
+   * \param params The channel matrix
+   * \param sSpeed speed of the first node
+   * \param uSpeed speed of the second node
+   * \return the rx PSD
+   */
+  Ptr<SpectrumValue> CalcBeamformingGain (Ptr<SpectrumValue> txPsd,
+                                          ThreeGppAntennaArrayModel::ComplexVector longTerm,
+                                          Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+                                          const Vector &sSpeed, const Vector &uSpeed) const;
+
+  std::unordered_map <uint32_t, Ptr<const ThreeGppAntennaArrayModel> > m_deviceAntennaMap; //!< map containig the <node, antenna> associations
+  mutable std::unordered_map < uint32_t, Ptr<const LongTerm> > m_longTermMap; //!< map containing the long term components
+  Ptr<MatrixBasedChannelModel> m_channelModel; //!< the model to generate the channel matrix
+};
+} // namespace ns3
+
+#endif /* THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/wifi-spectrum-value-helper.cc ns-3.31/src/spectrum/model/wifi-spectrum-value-helper.cc
--- ns-3.30.1/src/spectrum/model/wifi-spectrum-value-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/model/wifi-spectrum-value-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -83,7 +83,7 @@
 static std::map<WifiSpectrumModelId, Ptr<SpectrumModel> > g_wifiSpectrumModelMap; ///< static initializer for the class
 
 Ptr<SpectrumModel>
-WifiSpectrumValueHelper::GetSpectrumModel (uint32_t centerFrequency, uint16_t channelWidth, double bandBandwidth, uint16_t guardBandwidth)
+WifiSpectrumValueHelper::GetSpectrumModel (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, uint16_t guardBandwidth)
 {
   NS_LOG_FUNCTION (centerFrequency << channelWidth << bandBandwidth << guardBandwidth);
   Ptr<SpectrumModel> ret;
@@ -137,7 +137,7 @@
 {
   NS_LOG_FUNCTION (centerFrequency << txPowerW << +guardBandwidth);
   uint16_t channelWidth = 22;  // DSSS channels are 22 MHz wide
-  double bandBandwidth = 312500;
+  uint32_t bandBandwidth = 312500;
   Ptr<SpectrumValue> c = Create<SpectrumValue> (GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth));
   Values::iterator vit = c->ValuesBegin ();
   Bands::const_iterator bit = c->ConstBandsBegin ();
@@ -160,7 +160,7 @@
 WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double txPowerW, uint16_t guardBandwidth)
 {
   NS_LOG_FUNCTION (centerFrequency << channelWidth << txPowerW << guardBandwidth);
-  double bandBandwidth = 0;
+  uint32_t bandBandwidth = 0;
   uint32_t innerSlopeWidth = 0;
   switch (channelWidth)
     {
@@ -213,7 +213,7 @@
 WifiSpectrumValueHelper::CreateHtOfdmTxPowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double txPowerW, uint16_t guardBandwidth)
 {
   NS_LOG_FUNCTION (centerFrequency << channelWidth << txPowerW << guardBandwidth);
-  double bandBandwidth = 312500;
+  uint32_t bandBandwidth = 312500;
   Ptr<SpectrumValue> c = Create<SpectrumValue> (GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth));
   uint32_t nGuardBands = static_cast<uint32_t> (((2 * guardBandwidth * 1e6) / bandBandwidth) + 0.5);
   uint32_t nAllocatedBands = static_cast<uint32_t> (((channelWidth * 1e6) / bandBandwidth) + 0.5);
@@ -330,7 +330,7 @@
 WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double txPowerW, uint16_t guardBandwidth)
 {
   NS_LOG_FUNCTION (centerFrequency << channelWidth << txPowerW << guardBandwidth);
-  double bandBandwidth = 78125;
+  uint32_t bandBandwidth = 78125;
   Ptr<SpectrumValue> c = Create<SpectrumValue> (GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth));
   uint32_t nGuardBands = static_cast<uint32_t> (((2 * guardBandwidth * 1e6) / bandBandwidth) + 0.5);
   uint32_t nAllocatedBands = static_cast<uint32_t> (((channelWidth * 1e6) / bandBandwidth) + 0.5);
@@ -359,7 +359,7 @@
       innerSlopeWidth = static_cast<uint32_t> ((5e5 / bandBandwidth) + 0.5); // [-10.25;-9.75] & [9.75;10.25]
       // skip the guard band and 6 subbands, then place power in 121 subbands, then
       // skip 3 DC, then place power in 121 subbands, then skip
-      // the final 6 subbands and the guard band.
+      // the final 5 subbands and the guard band.
       start1 = (nGuardBands / 2) + 6;
       stop1 = start1 + 121 - 1;
       start2 = stop1 + 4;
@@ -372,7 +372,7 @@
       txPowerPerBandW = txPowerW / 484;
       // skip the guard band and 12 subbands, then place power in 242 subbands, then
       // skip 5 DC, then place power in 242 subbands, then skip
-      // the final 12 subbands and the guard band.
+      // the final 11 subbands and the guard band.
       start1 = (nGuardBands / 2) + 12;
       stop1 = start1 + 242 - 1;
       start2 = stop1 + 6;
@@ -385,7 +385,7 @@
       txPowerPerBandW = txPowerW / 996;
       // skip the guard band and 12 subbands, then place power in 498 subbands, then
       // skip 5 DC, then place power in 498 subbands, then skip
-      // the final 12 subbands and the guard band.
+      // the final 11 subbands and the guard band.
       start1 = (nGuardBands / 2) + 12;
       stop1 = start1 + 498 - 1;
       start2 = stop1 + 6;
@@ -424,7 +424,7 @@
 }
 
 Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateNoisePowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double bandBandwidth, double noiseFigure, uint16_t guardBandwidth)
+WifiSpectrumValueHelper::CreateNoisePowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, double noiseFigure, uint16_t guardBandwidth)
 {
   Ptr<SpectrumModel> model = GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth);
   return CreateNoisePowerSpectralDensity (noiseFigure, model);
@@ -449,14 +449,13 @@
 }
 
 Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateRfFilter (uint32_t centerFrequency, uint16_t channelWidth, double bandGranularity, uint16_t guardBandwidth)
+WifiSpectrumValueHelper::CreateRfFilter (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, uint16_t guardBandwidth)
 {
-  NS_LOG_FUNCTION (centerFrequency << channelWidth << bandGranularity << guardBandwidth);
-  Ptr<SpectrumValue> c = Create <SpectrumValue> (GetSpectrumModel (centerFrequency, channelWidth, bandGranularity, guardBandwidth));
+  NS_LOG_FUNCTION (centerFrequency << channelWidth << bandBandwidth << guardBandwidth);
+  Ptr<SpectrumValue> c = Create <SpectrumValue> (GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth));
   size_t numBands = c->GetSpectrumModel ()->GetNumBands ();
   Bands::const_iterator bit = c->ConstBandsBegin ();
   Values::iterator vit = c->ValuesBegin ();
-  uint32_t bandBandwidth = static_cast<uint32_t> (bandGranularity);
   size_t numBandsInFilter = static_cast<size_t> (channelWidth * 1e6 / bandBandwidth);
   if (channelWidth % bandBandwidth != 0)
     {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/wifi-spectrum-value-helper.h ns-3.31/src/spectrum/model/wifi-spectrum-value-helper.h
--- ns-3.30.1/src/spectrum/model/wifi-spectrum-value-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/model/wifi-spectrum-value-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -57,7 +57,7 @@
    * \return the static SpectrumModel instance corresponding to the
    * given carrier frequency and channel width configuration.
    */
-  static Ptr<SpectrumModel> GetSpectrumModel (uint32_t centerFrequency, uint16_t channelWidth, double bandBandwidth, uint16_t guardBandwidth);
+  static Ptr<SpectrumModel> GetSpectrumModel (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, uint16_t guardBandwidth);
 
   /**
    * Create a transmit power spectral density corresponding to DSSS
@@ -123,7 +123,7 @@
    * \param guardBandwidth width of the guard band (MHz)
    * \return a pointer to a newly allocated SpectrumValue representing the noise Power Spectral Density in W/Hz for each Band
    */
-  static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double bandBandwidth, double noiseFigure, uint16_t guardBandwidth);
+  static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, double noiseFigure, uint16_t guardBandwidth);
 
   /**
    * Create a thermal noise power spectral density
@@ -145,7 +145,7 @@
    * \return a pointer to a SpectrumValue representing the RF filter applied
    * to an received power spectral density
    */
-  static Ptr<SpectrumValue> CreateRfFilter (uint32_t centerFrequency, uint16_t channelWidth, double bandBandwidth, uint16_t guardBandwidth);
+  static Ptr<SpectrumValue> CreateRfFilter (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, uint16_t guardBandwidth);
 
   /**
    * typedef for a pair of start and stop sub-band indexes
